.386
.model flat,stdcall
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include	plprocs.h

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib

pThread		PROTO	:DWORD
_parse		PROTO	:DWORD
dlg1		PROTO	:DWORD,:DWORD,:DWORD,:DWORD
dlg1proc	PROTO	:DWORD,:DWORD,:DWORD,:DWORD
dlg2proc	PROTO	:DWORD,:DWORD,:DWORD,:DWORD
dlg3proc	PROTO	:DWORD,:DWORD,:DWORD,:DWORD


qtimeout=20
scoreInfo	struct
	_next	dd	?
	_nick	db	40 dup(?)
	points	dd	?
	time	dd	?
scoreInfo	ends

.data?
	hInstance	dd	?
	hTab		dd	?
	tabsel		dd	?
	_locked		db	?
	tcitem		TC_ITEM	<>
	tdlg1		dd	?
	tdlg2		dd	?
	tdlg3		dd	?
	_started	db	?
	thrid		dd	?
	bothnd		dd	?
	hTrivStart	dd	?
	hTrivStarth	dd	?
	hTrivStop	dd	?
	hTrivStoph	dd	?
	hTrivScores	dd	?
	hTrivScoresh	dd	?
	hTrivLang	dd	?
	hTrivLangh	dd	?
	SendToAll	dd	?
	RegisterBot	dd	?
	UnregisterBot	dd	?
	RegisterCommand	dd	?
	UnregisterCommand dd	?
	RegisterHelpString dd	?
	UnregisterHelpString dd	?
	NickFromId	dd	?
	SendTo		dd	?
	AllocUserData	dd	?
	FreeUserData	dd	?
	GetUserData	dd	?
	SetUserData	dd	?
	GetMode		dd	?
	ModeTransform	dd	?
	SetLanguage	dd	?
	qsize		dd	?
	questions	dd	?
	scoruri		dd	?

	pldata=$
	tflags		db	?
	tstop		dw	?
	defpoints	dd	?
	maxscoretbl	dd	?
	language	db	?,?,?,?
	trivstart	db	50 dup(?)
	trivstarth	db	256 dup(?)
	trivstop	db	50 dup(?)
	trivstoph	db	256 dup(?)
	trivscores	db	50 dup(?)
	trivscoresh	db	256 dup(?)
	trivlang	db	50 dup(?)
	trivlangh	db	256 dup(?)
	_format		db	8192 dup(?)
	_format0	db	8192 dup(?)
	_format1	db	8192 dup(?)
	_format2	db	8192 dup(?)
	_format3	db	8192 dup(?)
	chatscn		db	8192 dup(?)
	maxscoresh	dd	?
	scores		db	50*1000 dup(?)
	plsize=$-pldata
	datafile	db	8192 dup(?)
	qfile		db	8192 dup(?)
	qptr		dd	?
	qtotal		dd	?
	qidx		dd	?
	quid		dd	?
	answer		db	1000 dup(?)
	hint		db	1000 dup(?)
	lastplayer	db	50 dup(?)
	lastpid		dd	?
	lastscore	dd	?
	lastpos		dd	?
	lastwin		dd	?
	answered	db	?
	answered1	db	?
	bread		dd	?
	noanswer	dw	?
	systime		SYSTEMTIME <>
	seed1		dd	?
	seed2		dd	?
	idx1		dd	?
	idx2		dd	?
	idx3		dd	?
	idx4		dd	?
	modetmp		db	10 dup(?)
	_qtmp		db	8192 dup(?)
	chatq		db	1024 dup(?)
	chatqt		dd	?
	bufmsg		db	32768 dup(?)
	hlptmp		db	32768 dup(?)
	buftmp		db	32768 dup(?)

.code
pluginName	db	'TriviaSpy v1.04',0
botname		db	'$MyINFO $ALL Trivia TriviaSpy 1.04 by Albu Cristian $ $Bot',1,'$$0$',0
msg1		db	'TriviaSpy v1.04 written by '
_about		db	'Albu Cristian, 2008',0
msg2		db	'Trivia was started by ',0
msg3		db	'Trivia was stopped by ',0
msg4		db	'High scores',0
msg5		db	'Trivia language was changed by ',0
msgn1		db	'Trivia was stopped because no questions were found.',0
msgn2		db	'Trivia was stopped because nobody is playing.',0
msgn3		db	'Trivia',39,'s configuration was changed, the game is now stopped.',0
trcmd1		db	'trivstart',0
trcmd2		db	'trivstop',0
trcmd3		db	'trivscores',0
trcmd4		db	'trivlang',0
hcmd1		db	'Starts a new Trivia Game',0
hcmd2		db	'Stops a started Trivia Game',0
hcmd3		db	'Show Trivia high scores',0
hcmd4		db	'Change language for Trivia questions',0
fn01		db	'SendToAll',0
fn02		db	'RegisterBotEx',0
fn03		db	'UnregisterBot',0
fn04		db	'RegisterCommand',0
fn05		db	'UnregisterCommand',0
fn06		db	'RegisterHelpString',0
fn07		db	'UnregisterHelpString',0
fn08		db	'NickFromId',0
fn09		db	'SendTo',0
fn10		db	'AllocUserData',0
fn11		db	'FreeUserData',0
fn12		db	'GetUserData',0
fn13		db	'SetUserData',0
fn14		db	'GetMode',0
fn15		db	'ModeTransform',0
fn16		db	'SetLanguage',0
pl_procs


DllEntry PROC dllInstance:DWORD,reason:DWORD,reserved1:DWORD
	.if reason==DLL_PROCESS_ATTACH
		push	dllInstance
		pop	hInstance
		mov	tabsel,0
	.elseif reason==DLL_PROCESS_DETACH
	.elseif reason==DLL_THREAD_ATTACH
	.else
	.endif
	xor	eax,eax
	inc	eax
	ret
DllEntry Endp

reghlp:	mov	ecx,edi
	mov	al,'!'
	stosb
	.while byte ptr[esi]
		movsb
	.endw
	mov	eax,92d0909h
	stosd
	call	copyedx
	mov	al,0
	stosb
	dec	edi
	push	6
	push	ecx
	push	edi
	call	RegisterHelpString
	inc	edi
	ret

regcmds:push	offset procfn
	push	offset trivstart
	call	RegisterCommand
	mov	hTrivStart,eax
	push	offset procfn
	push	offset trivstop
	call	RegisterCommand
	mov	hTrivStop,eax
	push	offset procfn
	push	offset trivscores
	call	RegisterCommand
	mov	hTrivScores,eax
	push	offset procfn
	push	offset trivlang
	call	RegisterCommand
	mov	hTrivLang,eax

	lea	edi,hlptmp
	lea	esi,trivstart
	lea	edx,trivstarth
	call	reghlp
	mov	hTrivStarth,eax
	lea	esi,trivstop
	lea	edx,trivstoph
	call	reghlp
	mov	hTrivStoph,eax
	lea	esi,trivscores
	lea	edx,trivscoresh
	call	reghlp
	mov	hTrivScoresh,eax
	lea	esi,trivlang
	lea	edx,trivlangh
	call	reghlp
	mov	hTrivLangh,eax
	ret

unregcmds:
	push	hTrivStart
	call	UnregisterCommand
	mov	hTrivStart,0
	push	hTrivStop
	call	UnregisterCommand
	mov	hTrivStop,0
	push	hTrivScores
	call	UnregisterCommand
	mov	hTrivScores,0
	push	hTrivLang
	call	UnregisterCommand
	mov	hTrivLang,0
	push	hTrivStarth
	call	UnregisterHelpString
	mov	hTrivStarth,0
	push	hTrivStoph
	call	UnregisterHelpString
	mov	hTrivStoph,0
	push	hTrivScoresh
	call	UnregisterHelpString
	mov	hTrivScoresh,0
	push	hTrivLangh
	call	UnregisterHelpString
	mov	hTrivLangh,0
	ret

include	dlg.h


InitPlugin	PROC	uses esi edi ebx GetAddr:DWORD
	mov	tflags,7
	mov	tstop,3
	mov	scoruri,0
	mov	qsize,0
	mov	_locked,0
	cld
	lea	edi,scores
	xor	eax,eax
	mov	ecx,sizeof scores
	rep	stosb
	mov	questions,eax
	mov	eax,maxscoretbl
	mov	maxscoresh,eax
	lea	esi,trcmd1
	lea	edi,trivstart
	mov	ecx,sizeof trcmd1
	rep	movsb
	lea	esi,trcmd2
	lea	edi,trivstop
	mov	ecx,sizeof trcmd2
	rep	movsb
	lea	esi,trcmd3
	lea	edi,trivscores
	mov	ecx,sizeof trcmd3
	rep	movsb
	lea	esi,trcmd4
	lea	edi,trivlang
	mov	ecx,sizeof trcmd4
	rep	movsb
	lea	esi,hcmd1
	lea	edi,trivstarth
	mov	ecx,sizeof hcmd1
	rep	movsb
	lea	esi,hcmd2
	lea	edi,trivstoph
	mov	ecx,sizeof hcmd2
	rep	movsb
	lea	esi,hcmd3
	lea	edi,trivscoresh
	mov	ecx,sizeof hcmd3
	rep	movsb
	lea	esi,hcmd4
	lea	edi,trivlangh
	mov	ecx,sizeof hcmd4
	rep	movsb
	lea	esi,msg_1
	lea	edi,_format
	mov	ecx,1024
	rep	movsb
	lea	esi,msg_2
	lea	edi,_format0
	mov	ecx,1024
	rep	movsb
	lea	esi,msg_3
	lea	edi,_format1
	mov	ecx,1024
	rep	movsb
	lea	esi,msg_4
	lea	edi,_format2
	mov	ecx,1024
	rep	movsb
	lea	esi,msg_5
	lea	edi,_format3
	mov	ecx,1024
	rep	movsb
	lea	esi,msg_6
	lea	edi,chatscn
	mov	ecx,1024
	rep	movsb
	mov	defpoints,100
	mov	maxscoretbl,100
	mov	dword ptr language,0

	call	getdatafile
	invoke	CreateFile,addr datafile,GENERIC_READ,0,0,OPEN_EXISTING,0,0
	.if eax!=INVALID_HANDLE_VALUE
		push	eax
		mov	edi,eax
		mov	ecx,plsize
		mov	edx,pldata
		invoke	ReadFile,edi,edx,ecx,addr bread,0
		call	CloseHandle
	.endif
	lea	edi,scoruri
	lea	esi,scores
	mov	ecx,maxscoretbl
	.while (byte ptr[esi]!=0)&&(ecx!=0)
		push	ecx
		invoke	GlobalAlloc,GPTR,sizeof scoreInfo
		mov	[edi],eax
		mov	edi,eax
		assume	edi:ptr scoreInfo
		mov	[edi]._next,0
		push	edi
		lea	edi,[edi]._nick
		mov	edx,esi
		call	copyedx
		mov	al,0
		stosb
		pop	edi
		mov	eax,[esi+50-8]
		mov	[edi].time,eax
		mov	eax,[esi+50-4]
		mov	[edi].points,eax
		assume	edi:nothing
		pop	ecx
		dec	ecx
		lea	esi,[esi+50]
	.endw
	lea	esi,datafile
	lea	edi,qfile
	mov	ecx,edi
	.while byte ptr[esi]
		lodsb
		.if al=='.'
			mov	ecx,edi
		.endif
		stosb
	.endw
	mov	edi,ecx
	mov	eax,'txt.'
	stosd
	mov	al,0
	stosb
	invoke	CreateFile,addr qfile,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,0,0
	.if eax!=INVALID_HANDLE_VALUE
		push	eax
		invoke	GetFileSize,eax,0
		lea	ecx,[eax+1024]
		mov	qsize,ecx
		push	eax
		invoke	GlobalAlloc,GPTR,ecx
		pop	ecx
		mov	edi,eax
		mov	questions,eax
		mov	edi,eax
		pop	eax
		push	eax
		invoke	ReadFile,eax,edi,ecx,addr bread,0
		add	edi,bread
		mov	byte ptr[edi],0
		call	CloseHandle
	.endif

	push	offset fn01
	call	GetAddr
	mov	SendToAll,eax
	push	offset fn02
	call	GetAddr
	mov	RegisterBot,eax
	push	offset fn03
	call	GetAddr
	mov	UnregisterBot,eax
	push	offset fn04
	call	GetAddr
	mov	RegisterCommand,eax
	push	offset fn05
	call	GetAddr
	mov	UnregisterCommand,eax
	push	offset fn06
	call	GetAddr
	mov	RegisterHelpString,eax
	push	offset fn07
	call	GetAddr
	mov	UnregisterHelpString,eax
	push	offset fn08
	call	GetAddr
	mov	NickFromId,eax
	push	offset fn09
	call	GetAddr
	mov	SendTo,eax
	push	offset fn10
	call	GetAddr
	mov	AllocUserData,eax
	push	offset fn11
	call	GetAddr
	mov	FreeUserData,eax
	push	offset fn12
	call	GetAddr
	mov	GetUserData,eax
	push	offset fn13
	call	GetAddr
	mov	SetUserData,eax
	push	offset fn14
	call	GetAddr
	mov	GetMode,eax
	push	offset fn15
	call	GetAddr
	mov	ModeTransform,eax
	push	offset fn16
	call	GetAddr
	mov	SetLanguage,eax
	push	999
	push	-1
	push	0FBFFFFFFh
	push	offset onPM
	push	offset botname
	call	RegisterBot
	mov	bothnd,eax
	push	offset language
	push	bothnd
	call	SetLanguage

	mov	_started,1
	mov	thrid,0
	invoke	CreateThread,0,0,addr pThread,0,0,addr thrid
	mov	thrid,eax
	push	edi
	lea	edi,bufmsg
	mov	al,'<'
	stosb
	push	edi
	push	bothnd
	call	NickFromId
	.while byte ptr[edi]
		inc	edi
	.endw
	mov	ax,' >'
	stosw
	lea	edx,msg1
	call	copyedx
	mov	al,'|'
	stosb
	mov	ecx,edi
	lea	edi,bufmsg
	sub	ecx,edi
	push	ecx
	push	edi
	call	SendToAll
	pop	edi

	call	regcmds

	call	AllocUserData
	mov	idx1,eax
	call	AllocUserData
	mov	idx2,eax
	call	AllocUserData
	mov	idx3,eax
	call	AllocUserData
	mov	idx4,eax
	lea	eax,pluginName
	mov	chatq,0
	ret
InitPlugin	ENDP

UnloadPlugin	PROC uses esi
	mov	_started,0
	.while _started==0
		invoke	Sleep,10
	.endw
	call	unregcmds
	push	bothnd
	call	UnregisterBot
	push	idx4
	call	FreeUserData
	push	idx3
	call	FreeUserData
	push	idx2
	call	FreeUserData
	push	idx1
	call	FreeUserData
	mov	esi,scoruri
	.while esi
		push	dword ptr[esi]
		invoke	GlobalFree,esi
		pop	esi
	.endw
	mov	scoruri,0
	ret
UnloadPlugin	ENDP

SaveSettings	PROC uses esi edi
	mov	esi,scoruri
	lea	edi,scores
	mov	ecx,maxscoretbl
	.while (ecx!=0)&&(esi!=0)
		push	edi
		assume	esi:ptr scoreInfo
		lea	edx,[esi]._nick
		call	copyedx
		mov	al,0
		stosb
		pop	edi
		push	edi
		mov	eax,[esi].time
		mov	[edi+50-8],eax
		mov	eax,[esi].points
		mov	[edi+50-4],eax
		assume	esi:nothing
		pop	edi
		dec	ecx
		mov	esi,[esi]
		lea	edi,[edi+50]
	.endw
	.if ecx
		mov	byte ptr[edi],0
	.endif
	invoke	SetFileAttributes,addr datafile,0
	invoke	DeleteFile,addr datafile
	invoke	CreateFile,addr datafile,GENERIC_WRITE,0,0,CREATE_ALWAYS,0,0
	.if eax!=INVALID_HANDLE_VALUE
		push	eax
		mov	edi,eax
		mov	ecx,plsize
		mov	edx,pldata
		invoke	WriteFile,edi,edx,ecx,addr bread,0
		call	CloseHandle
	.endif
	invoke	SetFileAttributes,addr qfile,0
	invoke	DeleteFile,addr qfile
	.if questions
		mov	esi,questions
		.if byte ptr[esi]
			invoke	CreateFile,addr qfile,GENERIC_WRITE,0,0,CREATE_ALWAYS,0,0
			.if eax!=INVALID_HANDLE_VALUE
				push	eax
				xor	ecx,ecx
				.while byte ptr[esi+ecx]
					inc	ecx
				.endw
				invoke	WriteFile,eax,esi,ecx,addr bread,0
				call	CloseHandle
			.endif
		.endif
	.endif
	ret
SaveSettings	ENDP

procfn	PROC	uses esi edi ebx cmdID:DWORD,userId:DWORD,lpRights:DWORD,lpParams:DWORD,isPM:DWORD
	mov	eax,cmdID
	.if (eax==hTrivStart)&&(_started<2)
		invoke	GlobalAlloc,GPTR,1024
		push	eax
		mov	edi,eax
		mov	al,'<'
		stosb
		push	edi
		push	bothnd
		call	NickFromId
		.while byte ptr[edi]
			inc	edi
		.endw
		mov	ax,' >'
		stosw
		lea	edx,msg2
		call	copyedx
		push	edi
		push	userId
		call	NickFromId
		.while byte ptr[edi]
			inc	edi
		.endw
		mov	al,'|'
		stosb
		mov	ecx,edi
		mov	edi,[esp]
		sub	ecx,edi
		push	ecx
		push	edi
		call	SendToAll
		mov	noanswer,0
		mov	_started,2
		call	GlobalFree
	.elseif (eax==hTrivStop)&&(_started>1)
		invoke	GlobalAlloc,GPTR,1024
		push	eax
		mov	edi,eax
		mov	al,'<'
		stosb
		push	edi
		push	bothnd
		call	NickFromId
		.while byte ptr[edi]
			inc	edi
		.endw
		mov	ax,' >'
		stosw
		lea	edx,msg3
		call	copyedx
		push	edi
		push	userId
		call	NickFromId
		.while byte ptr[edi]
			inc	edi
		.endw
		mov	al,'|'
		stosb
		mov	ecx,edi
		mov	edi,[esp]
		sub	ecx,edi
		push	ecx
		push	edi
		call	SendToAll
		mov	_started,1
		call	GlobalFree
		mov	chatq,0
	.elseif eax==hTrivScores
		mov	eax,maxscoretbl
		mov	ecx,50
		xor	edx,edx
		mul	ecx
		lea	eax,[eax+1024]
		invoke	GlobalAlloc,GPTR,eax
		push	eax
		mov	edi,eax
		mov	al,'<'
		stosb
		push	edi
		push	bothnd
		call	NickFromId
		.while byte ptr[edi]
			inc	edi
		.endw
		mov	ax,' >'
		stosw
		mov	eax,090a0dh
		stosd
		dec	edi
		lea	edx,msg4
		call	copyedx
		mov	eax,0a0d0a0dh
		stosd
		mov	esi,scoruri
		mov	ecx,maxscoretbl
		.while (ecx!=0)&&(esi!=0)
			assume	esi:ptr scoreInfo
			.break .if byte ptr[esi]._nick==0
			push	ecx
			mov	al,9
			stosb
			mov	eax,[esi].points
			.if eax&80000000h
				mov	byte ptr[edi],'-'
				inc	edi
				neg	eax
			.endif
			call	itoa
			mov	al,9
			stosb
			lea	edx,[esi]._nick
			call	copyedx
			mov	ax,0a0dh
			stosw
			assume	esi:nothing
			pop	ecx
			dec	ecx
			mov	esi,[esi]
		.endw
		mov	al,'|'
		stosb
		mov	ecx,edi
		mov	edi,[esp]
		sub	ecx,edi
		push	ecx
		push	edi
		push	userId
		call	SendTo
		call	GlobalFree
	.elseif eax==hTrivLang
		invoke	GlobalAlloc,GPTR,1024
		push	eax
		mov	edi,eax
		mov	al,'<'
		stosb
		push	edi
		push	bothnd
		call	NickFromId
		.while byte ptr[edi]
			inc	edi
		.endw
		mov	ax,' >'
		stosw
		lea	edx,msg5
		call	copyedx
		push	edi
		push	userId
		call	NickFromId
		.while byte ptr[edi]
			inc	edi
		.endw
		mov	eax,' ot '
		stosd
		mov	edx,lpParams
		.while (byte ptr[edx]==32)||(byte ptr[edx]==9)||(byte ptr[edx]==13)||(byte ptr[edx]==10)
			inc	edx
		.endw
		mov	ecx,2
		.while (byte ptr[edx]>32)&&(byte ptr[edx]!='|')&&(ecx!=0)
			mov	al,[edx]
			.if (al>='a')&&(al<='z')
				sub	al,32
			.endif
			stosb
			inc	edx
			dec	ecx
		.endw
		mov	al,'|'
		stosb
		mov	ecx,edi
		mov	edi,[esp]
		sub	ecx,edi
		push	ecx
		push	edi
		call	SendToAll
		call	GlobalFree
		lea	edi,language
		mov	edx,lpParams
		.while (byte ptr[edx]==32)||(byte ptr[edx]==9)||(byte ptr[edx]==13)||(byte ptr[edx]==10)
			inc	edx
		.endw
		mov	ecx,2
		.while (byte ptr[edx]>32)&&(byte ptr[edx]!='|')&&(ecx!=0)
			mov	al,[edx]
			.if (al>='a')&&(al<='z')
				sub	al,32
			.endif
			stosb
			inc	edx
			dec	ecx
		.endw
		mov	al,0
		stosb
		push	offset language
		push	bothnd
		call	SetLanguage
	.endif
	ret
procfn	ENDP

msgpm	db	'Don',39,'t talk to me ! <Trivia 1.04>|',0
onPM	PROC uses esi edi botID:DWORD,userID:DWORD,lpBuf:DWORD,szBuf:DWORD
	invoke	GlobalAlloc,GPTR,1024
	push	eax
	mov	edi,eax
	mov	eax,':oT$'
	stosd
	mov	al,32
	stosb
	push	edi
	push	userID
	call	NickFromId
	.while byte ptr[edi]
		inc	edi
	.endw
	mov	eax,'orF '
	stosd
	mov	eax,' :m'
	stosd
	dec	edi
	push	edi
	push	botID
	call	NickFromId
	.while byte ptr[edi]
		inc	edi
	.endw
	mov	eax,'<$ '
	stosd
	dec	edi
	push	edi
	push	botID
	call	NickFromId
	.while byte ptr[edi]
		inc	edi
	.endw
	mov	ax,' >'
	stosw
	lea	edx,msgpm
	call	copyedx
	mov	ecx,edi
	pop	edi
	push	edi
	sub	ecx,edi
	push	ecx
	push	edi
	push	userID
	call	SendTo
	call	GlobalFree
	ret
onPM	ENDP

HTTPEnumData	PROC	uses esi edi ebx userId:DWORD,lpszPath:DWORD,lpszHost:DWORD,lpszReferer:DWORD,lpszUserAgent:DWORD,lpszCookies:DWORD,lpVariabiles:DWORD,enumerationIndex:DWORD,lpParameters:DWORD,lpBuffer:DWORD,dataOffset:DWORD
	local	_line:DWORD
	mov	eax,enumerationIndex
	.if eax>=maxscoresh
		xor	eax,eax
		dec	eax
		ret
	.elseif dataOffset
		xor	eax,eax
		dec	eax
		ret
	.endif
	mov	edi,lpBuffer
	mov	edx,scoruri
	.while (ecx!=0)&&(edx!=0)
		mov	edx,[edx]
		dec	ecx
	.endw
	.if edx==0
		xor	eax,eax
		dec	eax
		ret
	.endif
	assume	edx:ptr scoreInfo
	push	edx
	lea	edx,[edx]._nick
	call	copyedx
	mov	edx,lpParameters
	.while (byte ptr[edx]!=0)&&(byte ptr[edx]!=']')
		mov	al,byte ptr[edx]
		stosb
		inc	edx
	.endw
	pop	edx
	mov	eax,[edx].points
	.if eax&80000000h
		mov	byte ptr[edi],'-'
		inc	edi
		neg	eax
	.endif
	call	itoa
	assume	edx:nothing
	mov	eax,edi
	sub	eax,lpBuffer
	ret
HTTPEnumData	ENDP

showmsg:push	edi
	lea	edi,bufmsg
	mov	al,'<'
	stosb
	push	edx
	push	edi
	push	bothnd
	call	NickFromId
	pop	edx
	.while byte ptr[edi]
		inc	edi
	.endw
	mov	ax,' >'
	stosw
	call	copyedx
	mov	al,'|'
	stosb
	mov	ecx,edi
	lea	edi,bufmsg
	sub	ecx,edi
	push	ecx
	push	edi
	call	SendToAll
	pop	edi
	ret

skipm:	.while byte ptr[edx]
		.if byte ptr[edx]==']'
			inc	edx
			ret
		.endif
		.if word ptr[edx]=='[%'
			inc	edx
			call	skipm
		.else
			inc	edx
		.endif
	.endw
	ret
expmacro:
	xor	ecx,ecx
	inc	ecx
	inc	ecx
	.while (byte ptr[edx+ecx]!=0)&&(byte ptr[edx+ecx]!=']')
		.if word ptr[edx+ecx]=='[%'
			mov	eax,[edx+ecx+2]
			or	eax,20202020h
			.if eax=='niop'
				push	edx
				mov	edx,qptr
				xor	ecx,ecx
				.while (byte ptr[edx]!=0)&&(byte ptr[edx]!=13)&&(byte ptr[edx]!=10)
					.if byte ptr[edx]=='|'
						inc	ecx
						inc	edx
						.break .if ecx==5
					.else
						inc	edx
					.endif
				.endw
				.if (ecx!=5)||(byte ptr[edx]==13)||(byte ptr[edx]==10)||(byte ptr[edx]==0)||(byte ptr[edx]=='|')
					pop	edx
					inc	edx
					call	skipm
					ret
				.endif
				pop	edx
			.elseif eax=='gnal'
				push	edx
				mov	edx,qptr
				.if (byte ptr[edx]==13)||(byte ptr[edx]==10)||(byte ptr[edx]==0)||(byte ptr[edx]=='|')
					pop	edx
					inc	edx
					call	skipm
					ret
				.endif
				pop	edx
			.elseif eax=='etac'
				push	edx
				mov	edx,qptr
				xor	ecx,ecx
				.while (byte ptr[edx]!=0)&&(byte ptr[edx]!=13)&&(byte ptr[edx]!=10)
					.if byte ptr[edx]=='|'
						inc	edx
						.break
					.else
						inc	edx
					.endif
				.endw
				.if (byte ptr[edx]==13)||(byte ptr[edx]==10)||(byte ptr[edx]==0)||(byte ptr[edx]=='|')
					pop	edx
					inc	edx
					call	skipm
					ret
				.endif
				pop	edx
			.elseif eax=='htua'
				push	edx
				mov	edx,qptr
				xor	ecx,ecx
				.while (byte ptr[edx]!=0)&&(byte ptr[edx]!=13)&&(byte ptr[edx]!=10)
					.if byte ptr[edx]=='|'
						inc	ecx
						inc	edx
						.break .if ecx==2
					.else
						inc	edx
					.endif
				.endw
				.if (ecx!=2)||(byte ptr[edx]==13)||(byte ptr[edx]==10)||(byte ptr[edx]==0)||(byte ptr[edx]=='|')
					pop	edx
					inc	edx
					call	skipm
					ret
				.endif
				pop	edx
			.elseif eax=='seuq'
				push	edx
				mov	edx,qptr
				xor	ecx,ecx
				.while (byte ptr[edx]!=0)&&(byte ptr[edx]!=13)&&(byte ptr[edx]!=10)
					.if byte ptr[edx]=='|'
						inc	ecx
						inc	edx
						.break .if ecx==3
					.else
						inc	edx
					.endif
				.endw
				.if (ecx!=3)||(byte ptr[edx]==13)||(byte ptr[edx]==10)||(byte ptr[edx]==0)||(byte ptr[edx]=='|')
					pop	edx
					inc	edx
					call	skipm
					ret
				.endif
				pop	edx
			.elseif (eax=='wsna')&&(answer==0)
				inc	edx
				call	skipm
				ret
			.elseif (eax=='tnih')&&(hint==0)
				inc	edx
				call	skipm
				ret
			.endif
			inc	edx
			inc	edx
			.while (byte ptr[edx]!=0)&&(byte ptr[edx]!=']')
				.if word ptr[edx]=='[%'
					call	expmacro
				.else
					mov	al,[edx]
					.if al=='|'
						mov	eax,'21#&'
						stosd
						mov	ax,';4'
						stosw
					.elseif al=='$'
						mov	eax,'63#&'
						stosd
						mov	al,';'
						stosb
					.elseif al=='&'
						mov	eax,'pma&'
						stosd
						mov	al,';'
						stosb
					.else
						stosb
					.endif
					inc	edx
				.endif
			.endw
			.if byte ptr[edx]==']'
				inc	edx
			.endif
			ret
		.endif
		inc	ecx
	.endw
	mov	eax,[edx+2]
	or	eax,20202020h
	.if (eax=='emit')
		push	edx
		movzx	eax,systime.wHour
		call	w2
		mov	al,':'
		stosb
		movzx	eax,systime.wMinute
		call	w2
		mov	al,':'
		stosb
		movzx	eax,systime.wSecond
		call	w2
		pop	edx
		.while (byte ptr[edx]!=0)&&(byte ptr[edx]!=']')
			inc	edx
		.endw
		.if byte ptr[edx]==']'
			inc	edx
		.endif
	.elseif eax=='etad'
		push	edx
		movzx	eax,systime.wYear
		call	w4
		mov	al,'-'
		stosb
		movzx	eax,systime.wMonth
		call	w2
		mov	al,'-'
		stosb
		movzx	eax,systime.wDay
		call	w2
		pop	edx
		.while (byte ptr[edx]!=0)&&(byte ptr[edx]!=']')
			inc	edx
		.endw
		.if byte ptr[edx]==']'
			inc	edx
		.endif
	.elseif eax=='atot'
		mov	eax,qtotal
		push	edx
		call	itoa
		pop	edx
		.while (byte ptr[edx]!=0)&&(byte ptr[edx]!=']')
			inc	edx
		.endw
		.if byte ptr[edx]==']'
			inc	edx
		.endif
	.elseif eax=='edni'
		mov	eax,qidx
		push	edx
		call	itoa
		pop	edx
		.while (byte ptr[edx]!=0)&&(byte ptr[edx]!=']')
			inc	edx
		.endw
		.if byte ptr[edx]==']'
			inc	edx
		.endif
	.elseif eax=='niop'
		push	edx
		mov	edx,qptr
		xor	ecx,ecx
		.while (byte ptr[edx]!=0)&&(byte ptr[edx]!=13)&&(byte ptr[edx]!=10)
			.if byte ptr[edx]=='|'
				inc	ecx
				inc	edx
				.break .if ecx==5
			.else
				inc	edx
			.endif
		.endw
		.if ecx!=5
			mov	eax,defpoints
		.else
			push	esi
			mov	esi,edx
			call	atoi
			pop	esi
		.endif
		xor	ecx,ecx
		xor	edx,edx
		.while hint[ecx]
			.if hint[ecx]=='@'
				inc	edx
			.endif
			inc	ecx
		.endw
		push	ecx
		mov	ecx,edx
		xor	edx,edx
		mul	ecx
		pop	ecx
		xor	edx,edx
		.if ecx
			div	ecx
		.else
			xor	eax,eax
		.endif
		.if eax==0
			inc	eax
		.endif
		call	itoa
		pop	edx
		.while (byte ptr[edx]!=0)&&(byte ptr[edx]!=']')
			inc	edx
		.endw
		.if byte ptr[edx]==']'
			inc	edx
		.endif
	.elseif eax=='gnal'
		push	edx
		mov	edx,qptr
		xor	ecx,ecx
		.while (byte ptr[edx]!='|')&&(byte ptr[edx]!=13)&&(byte ptr[edx]!=0)&&(byte ptr[edx]!=0)&&(ecx<1024)
			mov	al,[edx]
			stosb
			inc	edx
			inc	ecx
		.endw
		pop	edx
		.while (byte ptr[edx]!=0)&&(byte ptr[edx]!=']')
			inc	edx
		.endw
		.if byte ptr[edx]==']'
			inc	edx
		.endif
	.elseif eax=='etac'
		push	edx
		mov	edx,qptr
		xor	ecx,ecx
		.while (byte ptr[edx]!=0)&&(byte ptr[edx]!=13)&&(byte ptr[edx]!=10)
			.if byte ptr[edx]=='|'
				.break
			.else
				inc	edx
			.endif
		.endw
		.if byte ptr[edx]=='|'
			inc	edx
			xor	ecx,ecx
			.while (byte ptr[edx]!='|')&&(byte ptr[edx]!=13)&&(byte ptr[edx]!=0)&&(byte ptr[edx]!=0)&&(ecx<1024)
				mov	al,[edx]
				stosb
				inc	edx
				inc	ecx
			.endw
		.endif
		pop	edx
		.while (byte ptr[edx]!=0)&&(byte ptr[edx]!=']')
			inc	edx
		.endw
		.if byte ptr[edx]==']'
			inc	edx
		.endif
	.elseif eax=='htua'
		push	edx
		mov	edx,qptr
		xor	ecx,ecx
		.while (byte ptr[edx]!=0)&&(byte ptr[edx]!=13)&&(byte ptr[edx]!=10)
			.if byte ptr[edx]=='|'
				inc	ecx
				.break .if ecx==2
				inc	edx
			.else
				inc	edx
			.endif
		.endw
		.if byte ptr[edx]=='|'
			inc	edx
			xor	ecx,ecx
			.while (byte ptr[edx]!='|')&&(byte ptr[edx]!=13)&&(byte ptr[edx]!=0)&&(byte ptr[edx]!=0)&&(ecx<1024)
				mov	al,[edx]
				stosb
				inc	edx
				inc	ecx
			.endw
		.endif
		pop	edx
		.while (byte ptr[edx]!=0)&&(byte ptr[edx]!=']')
			inc	edx
		.endw
		.if byte ptr[edx]==']'
			inc	edx
		.endif
	.elseif eax=='seuq'
		push	edx
		mov	edx,qptr
		xor	ecx,ecx
		.while (byte ptr[edx]!=0)&&(byte ptr[edx]!=13)&&(byte ptr[edx]!=10)
			.if byte ptr[edx]=='|'
				inc	ecx
				.break .if ecx==3
				inc	edx
			.else
				inc	edx
			.endif
		.endw
		.if byte ptr[edx]=='|'
			inc	edx
			xor	ecx,ecx
			.while (byte ptr[edx]!='|')&&(byte ptr[edx]!=13)&&(byte ptr[edx]!=0)&&(byte ptr[edx]!=0)&&(ecx<1024)
				mov	al,[edx]
				stosb
				inc	edx
				inc	ecx
			.endw
		.endif
		pop	edx
		.while (byte ptr[edx]!=0)&&(byte ptr[edx]!=']')
			inc	edx
		.endw
		.if byte ptr[edx]==']'
			inc	edx
		.endif
	.elseif eax=='wsna'
		push	edx
		lea	edx,answer
		call	copyedx
		pop	edx
		.while (byte ptr[edx]!=0)&&(byte ptr[edx]!=']')
			inc	edx
		.endw
		.if byte ptr[edx]==']'
			inc	edx
		.endif
	.elseif eax=='tnih'
		push	edx
		lea	edx,hint
		call	copyedx
		pop	edx
		.while (byte ptr[edx]!=0)&&(byte ptr[edx]!=']')
			inc	edx
		.endw
		.if byte ptr[edx]==']'
			inc	edx
		.endif
	.elseif eax=='yalp'
		push	edx
		lea	edx,lastplayer
		call	copyedx
		pop	edx
		.while (byte ptr[edx]!=0)&&(byte ptr[edx]!=']')
			inc	edx
		.endw
		.if byte ptr[edx]==']'
			inc	edx
		.endif
	.elseif eax=='rocs'
		push	edx
		mov	eax,lastscore
		.if eax&80000000h
			mov	byte ptr[edi],'-'
			inc	edi
			neg	eax
		.endif
		call	itoa
		pop	edx
		.while (byte ptr[edx]!=0)&&(byte ptr[edx]!=']')
			inc	edx
		.endw
		.if byte ptr[edx]==']'
			inc	edx
		.endif
	.elseif eax=='isop'
		push	edx
		mov	eax,lastpos
		call	itoa
		pop	edx
		.while (byte ptr[edx]!=0)&&(byte ptr[edx]!=']')
			inc	edx
		.endw
		.if byte ptr[edx]==']'
			inc	edx
		.endif
	.elseif ax=='ow'
		push	edx
		mov	eax,lastwin
		.if eax&80000000h
			neg	eax
			push	eax
			sub	lastscore,eax
			push	esi
			push	edi
			push	ebx
			call	setscore
			pop	ebx
			pop	edi
			pop	esi
			pop	eax
		.endif
		call	itoa
		pop	edx
		.while (byte ptr[edx]!=0)&&(byte ptr[edx]!=']')
			inc	edx
		.endw
		.if byte ptr[edx]==']'
			inc	edx
		.endif
	.elseif ax=='nr'
		xor	ecx,ecx
		inc	ecx
		push	edx
		.while (byte ptr[edx]!=0)
			.if word ptr[edx]=='[%'
				mov	ax,[edx+2]
				or	ax,2020h
				.if ax=='nr'
					inc	ecx
				.elseif (byte ptr[edx+2]=='/')
					mov	ax,[edx+3]
					or	ax,2020h
					.break .if ax=='nr'
				.endif
				inc	edx
			.else
				inc	edx
			.endif
		.endw
		call	rnd
		mov	ecx,eax
		pop	edx
		push	edx
		.while (byte ptr[edx]!=0)&&(ecx!=0)
			.if word ptr[edx]=='[%'
				mov	ax,[edx+2]
				or	ax,2020h
				.if ax=='nr'
					dec	ecx
				.elseif (byte ptr[edx+2]=='/')
					mov	ax,[edx+3]
					or	ax,2020h
					.if ax=='nr'
						int 3
					.endif
				.endif
				inc	edx
			.else
				inc	edx
			.endif
		.endw
		.while (byte ptr[edx]!=0)&&(byte ptr[edx]!=']')
			inc	edx
		.endw
		.if byte ptr[edx]==']'
			inc	edx
		.endif
		.while byte ptr[edx]
			.if word ptr[edx]=='[%'
				mov	ax,[edx+2]
				or	ax,2020h
				.break .if ax=='nr'
				.if (byte ptr[edx+2]=='/')
					mov	ax,[edx+3]
					or	ax,2020h
					.break .if ax=='nr'
				.endif
				call	expmacro
			.else
				mov	al,[edx]
				.if al=='|'
					mov	eax,'21#&'
					stosd
					mov	ax,';4'
					stosw
				.elseif al=='$'
					mov	eax,'63#&'
					stosd
					mov	al,';'
					stosb
				.elseif al=='&'
					mov	eax,'pma&'
					stosd
					mov	al,';'
					stosb
				.else
					stosb
				.endif
				inc	edx
			.endif
		.endw
		pop	edx
		.while byte ptr[edx]
			.if word ptr[edx]=='[%'
				.if (byte ptr[edx+2]=='/')
					mov	ax,[edx+3]
					or	ax,2020h
					.if ax=='nr'
						lea	edx,[edx+3]
						.while (byte ptr[edx]!=0)&&(byte ptr[edx]!=']')
							inc	edx
						.endw
						.if byte ptr[edx]==']'
							inc	edx
						.endif
						.break
					.endif
				.endif
			.endif
			inc	edx
		.endw
	.else
		mov	al,[edx]
		stosb
		inc	edx
	.endif
	ret

_parse	PROC	wins:DWORD
	.while byte ptr[edx]
		.if word ptr[edx]=='[%'
			call	expmacro
		.else
			mov	al,[edx]
			.if al=='|'
				mov	eax,'21#&'
				stosd
				mov	ax,';4'
				stosw
			.elseif al=='$'
				mov	eax,'63#&'
				stosd
				mov	al,';'
				stosb
			.elseif al=='&'
				mov	eax,'pma&'
				stosd
				mov	al,';'
				stosb
			.else
				stosb
			.endif
			inc	edx
		.endif
	.endw
	ret
_parse	ENDP

delayme:
	xor	edx,edx
	.while (_started!=0)&&(ecx!=0)&&(answered==0)
		push	edx
		push	ecx
		invoke	Sleep,100
		pop	ecx
		pop	edx
		dec	ecx
		inc	edx
		.if answered1
			push	ecx
			push	edx
			push	esi
			push	edi
			invoke	GetLocalTime,addr systime
			lea	edi,bufmsg
			mov	al,'<'
			stosb
			push	edi
			push	bothnd
			call	NickFromId
			.while byte ptr[edi]
				inc	edi
			.endw
			mov	ax,' >'
			stosw

			mov	edx,qptr
			xor	ecx,ecx
			.while (byte ptr[edx]!=0)&&(byte ptr[edx]!=13)&&(byte ptr[edx]!=10)
				.if byte ptr[edx]=='|'
					inc	ecx
					inc	edx
					.break .if ecx==5
				.else
					inc	edx
				.endif
			.endw
			.if ecx!=5
				mov	eax,defpoints
			.else
				push	esi
				mov	esi,edx
				call	atoi
				pop	esi
			.endif
			mov	ecx,eax
			.if eax
				call	rnd
			.endif
			.if eax==0
				inc	eax
			.endif

			lea	edx,_format1
			push	edi
			neg	eax
			mov	lastwin,eax
			invoke	_parse,eax
			pop	edx
			.if edi!=edx
				mov	al,'|'
				stosb
				mov	ecx,edi
				lea	edi,bufmsg
				sub	ecx,edi
				.if ecx<4096
					push	ecx
					push	edi
					call	SendToAll
				.endif
			.endif
			pop	edi
			pop	esi
			pop	edx
			pop	ecx
			mov	answered1,0
		.endif
	.endw
	.if answered
		mov	_started,4
	.endif
	ret

setscore:
	mov	esi,scoruri
	.while esi
		assume	esi:ptr scoreInfo
		lea	edx,lastplayer
		lea	ebx,[esi]._nick
		.while byte ptr[ebx]
			mov	al,[ebx]
			mov	ah,[edx]
			or	ax,2020h
			.break .if al!=ah
			inc	ebx
			inc	edx
		.endw
		.break .if (byte ptr[ebx]==0)&&(byte ptr[edx]==0)
		assume	esi:nothing
		mov	esi,[esi]
	.endw
	assume	esi:ptr scoreInfo
	.if esi==0
		invoke	GlobalAlloc,GPTR,sizeof scoreInfo
		lea	esi,scoruri
		.while dword ptr[esi]
			mov	esi,[esi]._next
		.endw
		mov	[esi]._next,eax
		mov	esi,eax
		assume	esi:ptr scoreInfo
		mov	[esi]._next,0
		lea	edx,lastplayer
		lea	edi,[esi]._nick
		call	copyedx
		mov	al,0
		stosb
	.endif
	invoke	GetTickCount
	mov	[esi].time,eax
	mov	eax,lastscore
	mov	[esi].points,eax
	lea	edx,scoruri
	mov	ebx,scoruri
	assume	ebx:ptr scoreInfo

	lea	ecx,scoruri
	mov	eax,[esi].points
	mov	edi,esi
	.if eax&80000000h
		neg	eax
		.while ecx
			mov	esi,[ecx]
			.if esi
				.if [esi].points>eax
					.if edi!=[ecx]
						mov	esi,dword ptr[edi]
						mov	eax,dword ptr[ecx]
						xchg	dword ptr[edi],eax
						mov	[ecx],edi
						mov	ecx,edi
						.while ecx
							.if edi==[ecx]
								mov	[ecx],esi
								.break
							.endif
							mov	ecx,[ecx]
						.endw
					.endif
					.break
				.endif
			.endif
			mov	ecx,[ecx]
		.endw
	.else
		.while ecx
			mov	esi,[ecx]
			.if esi
				.if [esi].points<eax
					.if edi!=[ecx]
						mov	esi,dword ptr[edi]
						mov	eax,dword ptr[ecx]
						xchg	dword ptr[edi],eax
						mov	[ecx],edi
						mov	ecx,edi
						.while ecx
							.if edi==[ecx]
								mov	[ecx],esi
								.break
							.endif
							mov	ecx,[ecx]
						.endw
					.endif
					.break
				.endif
			.endif
			mov	ecx,[ecx]
		.endw
	.endif
	assume	ebx:nothing
	assume	esi:nothing
	ret

	movzx	eax,byte ptr lastscore
	push	eax
	push	idx1
	push	lastpid
	call	SetUserData
	movzx	eax,byte ptr lastscore[1]
	push	eax
	push	idx2
	push	lastpid
	call	SetUserData
	movzx	eax,byte ptr lastscore[2]
	push	eax
	push	idx3
	push	lastpid
	call	SetUserData
	movzx	eax,byte ptr lastscore[3]
	push	eax
	push	idx4
	push	lastpid
	call	SetUserData
	ret

getscore:
	mov	esi,scoruri
	.while esi
		assume	esi:ptr scoreInfo
		lea	edx,lastplayer
		lea	ebx,[esi]._nick
		.while byte ptr[ebx]
			mov	al,[ebx]
			mov	ah,[edx]
			or	ax,2020h
			.break .if al!=ah
			inc	ebx
			inc	edx
		.endw
		.break .if (byte ptr[ebx]==0)&&(byte ptr[edx]==0)
		assume	esi:nothing
		mov	esi,[esi]
	.endw
	.if esi
		assume	esi:ptr scoreInfo
		mov	eax,[esi].points
		assume	esi:nothing
		mov	lastscore,eax
	.else
		mov	lastscore,0
	.endif
	ret
	push	idx1
	push	lastpid
	call	GetUserData
	mov	byte ptr lastscore,al
	push	idx2
	push	lastpid
	call	GetUserData
	mov	byte ptr lastscore[1],al
	push	idx3
	push	lastpid
	call	GetUserData
	mov	byte ptr lastscore[2],al
	push	idx4
	push	lastpid
	call	GetUserData
	mov	byte ptr lastscore[3],al
	ret
mode0	db	'0',0
_mode0:	push	esi
	push	edi
	lea	edi,buftmp
	push	ecx
	.while ecx
		.break .if (byte ptr[esi]=='|')||(byte ptr[esi]==0)||(byte ptr[esi]==13)||(byte ptr[esi]==10)
		movsb
		dec	ecx
	.endw
	mov	al,0
	stosb
	push	offset bufmsg
	push	offset buftmp
	push	offset mode0
	push	bothnd
	call	ModeTransform
	mov	bufmsg[eax],0
	pop	ecx
	pop	edi
	lea	edx,bufmsg
	.while (byte ptr[edx]!=0)&&(byte ptr[edx]!='|')&&(ecx!=0)
		mov	al,[edx]
		.if al=='|'
			mov	al,'_'
		.endif
		stosb
		inc	edx
		dec	ecx
	.endw
	pop	esi
	.while (byte ptr[esi]!='|')&&(byte ptr[esi]!=0)&&(byte ptr[esi]!=13)&&(byte ptr[esi]!=10)
		inc	esi
	.endw
	.if byte ptr[esi]=='|'
		inc	esi
	.endif
	mov	al,'|'
	stosb
	ret
;_mode0:
	.while ecx
		.break .if (byte ptr[esi]=='|')||(byte ptr[esi]==0)||(byte ptr[esi]==13)||(byte ptr[esi]==10)
		movsb
		dec	ecx
	.endw
	.while (byte ptr[esi]!='|')&&(byte ptr[esi]!=0)&&(byte ptr[esi]!=13)&&(byte ptr[esi]!=10)
		inc	esi
	.endw
	.if byte ptr[esi]=='|'
		inc	esi
	.endif
	mov	al,'|'
	stosb
	ret

;lang|cat|author/source|question|answer|points
pThread	PROC	lParam:DWORD
	mov	quid,-1
	mov	lastplayer,0
	mov	lastscore,0
	mov	lastpos,0
	mov	lastwin,0
	.while _started
		.while _started==1
			mov	quid,-1
			invoke	Sleep,100
		.endw
		.if _started==2
			mov	esi,questions
			.if (esi==0)||(byte ptr[esi]==0)
_noquestions:			lea	edx,msgn1
				call	showmsg
				mov	_started,1
				.continue
			.endif
			.while (byte ptr[esi]==13)||(byte ptr[esi]==10)||(byte ptr[esi]==32)||(byte ptr[esi]==9)
				inc	esi
			.endw
			.if (byte ptr[esi]==0)
				lea	edx,msgn1
				call	showmsg
				mov	_started,1
				.continue
			.endif
			invoke	Sleep,100
			.while 1
				xor	ecx,ecx
				.while byte ptr[esi]
					.while (byte ptr[esi]==13)||(byte ptr[esi]==10)||(byte ptr[esi]==32)||(byte ptr[esi]==9)
						inc	esi
					.endw
					.if byte ptr[esi]
						.if (language!=0)&&(byte ptr[esi]!='|')
							mov	ax,word ptr language
							or	ax,2020h
							mov	dx,[esi]
							or	dx,2020h
							.if ax==dx
								inc	ecx
							.endif
						.else
							inc	ecx
						.endif
						.while (byte ptr[esi]!=13)&&(byte ptr[esi]!=10)&&(byte ptr[esi]!=0)
							inc	esi
						.endw
					.endif
				.endw
				.if ecx==0
					jmp	_noquestions
				.endif
				mov	qtotal,ecx
				call	rnd
				mov	ecx,eax
				mov	qidx,ecx
				inc	qidx
				mov	esi,questions
				.while byte ptr[esi]
					.while (byte ptr[esi]==13)||(byte ptr[esi]==10)||(byte ptr[esi]==32)||(byte ptr[esi]==9)
						inc	esi
					.endw
					.if byte ptr[esi]
						.if (language!=0)&&(byte ptr[esi]!='|')
							mov	ax,word ptr language
							or	ax,2020h
							mov	dx,[esi]
							or	dx,2020h
							.if ax==dx
								.break .if ecx==0
								dec	ecx
							.endif
						.else
							.break .if ecx==0
							dec	ecx
						.endif
						.while (byte ptr[esi]!=13)&&(byte ptr[esi]!=10)&&(byte ptr[esi]!=0)
							inc	esi
						.endw
					.endif
				.endw
				.break ;.if byte ptr[esi]
			.endw
			push	offset modetmp
			push	bothnd
			call	GetMode
			mov	modetmp[eax],0
			.if (byte ptr modetmp=='*')&&(byte ptr modetmp[1]>='0')&&(byte ptr modetmp[1]<='4')
				mov	al,byte ptr modetmp[1]
				mov	modetmp,al
				mov	byte ptr modetmp[1],0
			.endif
			lea	edi,_qtmp
			mov	ecx,20
			call	_mode0
			mov	ecx,256
			call	_mode0
			mov	ecx,1000
			call	_mode0

			.if tflags&2
				push	esi
				push	edi
				lea	edi,buftmp
				mov	ecx,1000
				.while ecx
					.break .if (byte ptr[esi]=='|')||(byte ptr[esi]==0)||(byte ptr[esi]==13)||(byte ptr[esi]==10)
					movsb
					dec	ecx
				.endw
				mov	al,0
				stosb
				push	offset bufmsg
				push	offset buftmp
				push	offset modetmp
				push	bothnd
				call	ModeTransform
				mov	bufmsg[eax],0
				pop	edi
				lea	edx,bufmsg
				mov	ecx,1000
				.while (byte ptr[edx]!=0)&&(byte ptr[edx]!='|')&&(ecx!=0)
					mov	al,[edx]
					.if al=='|'
						mov	al,'_'
					.endif
					stosb
					inc	edx
					dec	ecx
				.endw
				pop	esi
				.while (byte ptr[esi]!='|')&&(byte ptr[esi]!=0)&&(byte ptr[esi]!=13)&&(byte ptr[esi]!=10)
					inc	esi
				.endw
				.if byte ptr[esi]=='|'
					inc	esi
				.endif
				mov	al,'|'
				stosb
			.else
				mov	ecx,1000
				call	_mode0
			.endif

			.if tflags&2
				push	esi
				push	edi
				lea	edi,buftmp
				mov	ecx,200
				.while ecx
					.break .if (byte ptr[esi]=='|')||(byte ptr[esi]==0)||(byte ptr[esi]==13)||(byte ptr[esi]==10)
					movsb
					dec	ecx
				.endw
				mov	al,0
				stosb
				push	offset bufmsg
				push	offset buftmp
				push	offset modetmp
				push	bothnd
				call	ModeTransform
				mov	bufmsg[eax],0
				pop	edi
				lea	edx,bufmsg
				mov	ecx,200
				.while (byte ptr[edx]!=0)&&(byte ptr[edx]!='|')&&(ecx!=0)
					mov	al,[edx]
					.if al=='|'
						mov	al,'_'
					.endif
					stosb
					inc	edx
					dec	ecx
				.endw
				pop	esi
				.while (byte ptr[esi]!='|')&&(byte ptr[esi]!=0)&&(byte ptr[esi]!=13)&&(byte ptr[esi]!=10)
					inc	esi
				.endw
				.if byte ptr[esi]=='|'
					inc	esi
				.endif
				mov	al,'|'
				stosb
			.else
				call	_mode0
			.endif
			mov	ecx,1000
			call	_mode0
			lea	esi,_qtmp

			mov	qptr,esi
			mov	edx,esi
			xor	ecx,ecx
			lea	edi,answer
			.while (byte ptr[edx]!=0)&&(byte ptr[edx]!=13)&&(byte ptr[edx]!=10)&&(ecx<200)
				.if byte ptr[edx]=='|'
					inc	ecx
					.break .if ecx==4
					inc	edx
				.else
					inc	edx
				.endif
			.endw
			.if byte ptr[edx]=='|'
				lea	esi,[edx+1]
				xor	ecx,ecx
				mov	ah,32
				.while (byte ptr[esi]!='|')&&(byte ptr[esi]!=13)&&(byte ptr[esi]!=0)&&(byte ptr[esi]!=0)&&(ecx<99)
					lodsb
					.if al<33
						mov	al,32
					.endif
					.if (al!=32)||(ah!=32)
						stosb
					.endif
					mov	ah,al
					inc	ecx
				.endw
			.endif
			.if edi!=offset answer
				.if byte ptr[edi-1]==32
					dec	edi
				.endif
			.endif
			mov	al,0
			stosb
			lea	esi,answer
			lea	edi,hint
			.while byte ptr[esi]
				lodsb
				.if al!=32
					mov	al,'@'
				.endif
				stosb
			.endw
			movsb

			invoke	GetLocalTime,addr systime
			lea	edi,bufmsg
			mov	al,'<'
			stosb
			push	edi
			push	bothnd
			call	NickFromId
			.while byte ptr[edi]
				inc	edi
			.endw
			mov	answered,0
			mov	answered1,0
			mov	ax,' >'
			stosw
			lea	edx,_format
			push	edi
			invoke	_parse,0
			pop	edx
			.if edi!=edx
				mov	al,'|'
				stosb
				mov	ecx,edi
				lea	edi,bufmsg
				sub	ecx,edi
				push	ecx
				push	edi
				mov	_started,3
				call	SendToAll
			.else
				mov	_started,3
			.endif
			mov	ecx,100
			call	delayme
		.elseif _started==3
			lea	esi,hint
			xor	ecx,ecx
			.while byte ptr[esi]
				.if byte ptr[esi]=='@'
					inc	ecx
				.endif
				inc	esi
			.endw
			.if ecx>1
				push	esi
				shr	ecx,1
				pop	edx
				sub	edx,offset hint
				.while ecx
					push	edx
					push	ecx
					mov	ecx,edx
					call	rnd
					pop	ecx
					.if hint[eax]=='@'
						mov	dl,answer[eax]
						mov	hint[eax],dl
						dec	ecx
					.endif
					pop	edx
				.endw
				invoke	GetLocalTime,addr systime
				lea	edi,bufmsg
				mov	al,'<'
				stosb
				push	edi
				push	bothnd
				call	NickFromId
				.while byte ptr[edi]
					inc	edi
				.endw
				mov	ax,' >'
				stosw
				lea	edx,_format0
				push	edi
				invoke	_parse,0
				pop	edx
				.if edi!=edx
					mov	al,'|'
					stosb
					mov	ecx,edi
					lea	edi,bufmsg
					sub	ecx,edi
					push	ecx
					push	edi
					call	SendToAll
				.endif
				mov	ecx,100
				call	delayme
			.else
				mov	ecx,5
				call	delayme
				mov	_started,2
				mov	answered,0
				invoke	GetLocalTime,addr systime
				lea	edi,bufmsg
				mov	al,'<'
				stosb
				push	edi
				push	bothnd
				call	NickFromId
				.while byte ptr[edi]
					inc	edi
				.endw
				mov	ax,' >'
				stosw
				lea	edx,_format3
				push	edi
				invoke	_parse,0
				pop	edx
				.if edi!=edx
					mov	al,'|'
					stosb
					mov	ecx,edi
					lea	edi,bufmsg
					sub	ecx,edi
					push	ecx
					push	edi
					call	SendToAll
				.endif
				.if tflags&1
					inc	noanswer
					movzx	eax,noanswer
					.if ax>=tstop
						lea	edx,msgn2
						call	showmsg
						mov	_started,1
						.continue
					.endif
				.else
					mov	noanswer,0
				.endif
				mov	ecx,20
				call	delayme
			.endif
		.elseif _started==4
			mov	_started,2
			mov	edx,qptr
			xor	ecx,ecx
			.while (byte ptr[edx]!=0)&&(byte ptr[edx]!=13)&&(byte ptr[edx]!=10)
				.if byte ptr[edx]=='|'
					inc	ecx
					inc	edx
					.break .if ecx==5
				.else
					inc	edx
				.endif
			.endw
			.if ecx!=5
				mov	eax,defpoints
			.else
				push	esi
				mov	esi,edx
				call	atoi
				pop	esi
			.endif
			xor	ecx,ecx
			xor	edx,edx
			.while hint[ecx]
				.if hint[ecx]=='@'
					inc	edx
				.endif
				inc	ecx
			.endw
			push	ecx
			mov	ecx,edx
			xor	edx,edx
			mul	ecx
			pop	ecx
			xor	edx,edx
			.if ecx
				div	ecx
			.else
				xor	eax,eax
			.endif
			.if eax==0
				inc	eax
			.endif
			mov	lastwin,eax
			add	lastscore,eax
			call	setscore
			lea	esi,hint
			.while byte ptr[esi]
				.if byte ptr[esi]!=32
					mov	byte ptr[esi],'@'
				.endif
				inc	esi
			.endw

				invoke	GetLocalTime,addr systime
				lea	edi,bufmsg
				mov	al,'<'
				stosb
				push	edi
				push	bothnd
				call	NickFromId
				.while byte ptr[edi]
					inc	edi
				.endw
				mov	ax,' >'
				stosw
				lea	edx,_format2
				push	edi
				invoke	_parse,0
				pop	edx
				.if edi!=edx
					mov	al,'|'
					stosb
					mov	ecx,edi
					lea	edi,bufmsg
					sub	ecx,edi
					push	ecx
					push	edi
					call	SendToAll
				.endif
			mov	_started,2
			mov	answered,0
			mov	answered1,0
			mov	ecx,20
			call	delayme
		.endif
	.endw
	mov	_started,-1
	invoke	CloseHandle,thrid
	invoke	ExitThread,0
	ret
pThread	ENDP

rustbl	db	'A B V G D E ZHZ I J K L M N O P '
	db	'R S T U F H TZCHSHSH',39,' YI',39,' YEYUYA'
	db	'a b v g d e zhz i j k l m n o p '
	db	'r s t u f h tzchshsh',39,' yi',39,' yeyuya'

_trans_:
	push	eax
	push	edi
	mov	edi,eax
	xor	ecx,ecx
	.while (byte ptr[esi]!=0)&&(byte ptr[esi]!='|')&&(ecx<1024)
		lodsb
		.if al==0a8h
			mov	al,'E'
		.elseif al==0b8h
			mov	al,'e'
		.elseif (al>0c0h)
			sub	al,0c0h
			movzx	eax,al
			mov	ax,word ptr rustbl[eax*2]
			.if ah!=32
				or	al,32
				stosb
				inc	ecx
				mov	al,ah
				.if al<='Z'
					.if (byte ptr[ebx+1]>0e0h)||(byte ptr[ebx+1]==0b8h)
						or	al,20h
					.endif
				.endif
			.endif
		.endif
		.if (al!=32)&&(al!=13)&&(al!=10)&&(al!=9)
			or	al,32
			stosb
			inc	ecx
		.elseif (edi!=dword ptr[esp+4])&&(byte ptr[edi-1]!=32)
			mov	al,32
			stosb
		.endif
	.endw
	mov	al,0
	stosb
	pop	esi
	push	esi
	xor	ecx,ecx
	.while (byte ptr[esi]!=0)&&(byte ptr[esi]!='|')&&(ecx<1024)
		lodsb
		.if al==0a8h
			mov	al,'E'
		.elseif al==0b8h
			mov	al,'e'
		.elseif (al>0c0h)
			sub	al,0c0h
			movzx	eax,al
			mov	ax,word ptr rustbl[eax*2]
			.if ah!=32
				or	al,32
				stosb
				inc	ecx
				mov	al,ah
				.if al<='Z'
					.if (byte ptr[ebx+1]>0e0h)||(byte ptr[ebx+1]==0b8h)
						or	al,20h
					.endif
				.endif
			.endif
		.endif
		.if (al!=32)&&(al!=13)&&(al!=10)&&(al!=9)
			or	al,32
			stosb
			inc	ecx
		.elseif (edi!=dword ptr[esp+4])&&(byte ptr[edi-1]!=32)
			mov	al,32
			stosb
		.endif
	.endw
	mov	al,0
	stosb
	pop	edi
	pop	esi
	ret

_delta=2
onChatMessage	PROC	uses esi edi ebx userId:DWORD,lpBuffer:DWORD,bufferSize:DWORD,rsvd1:DWORD,rsvd2:DWORD
	local	letters:DWORD,hAlloc:DWORD
	mov	eax,lpBuffer
	.if byte ptr[eax]!='<'
		xor	eax,eax
		inc	eax
		ret
	.endif
	.if (_started==3)&&(answered==0)&&(_locked==0)
		mov	_locked,1
		xor	ecx,ecx
		mov	esi,lpBuffer
		.if byte ptr[esi]=='<'
			.while word ptr[esi]!=' >'
				inc	esi
			.endw
			inc	esi
			inc	esi
			.while (byte ptr[esi]==32)||(byte ptr[esi]==9)||(byte ptr[esi]==13)||(byte ptr[esi]==10)
				inc	esi
			.endw
			lea	edi,hint
			invoke	GlobalAlloc,GPTR,8192
			mov	hAlloc,eax
			call	_trans_
			.while 1
				xor	ecx,ecx
				.while (byte ptr[esi+ecx]>32)&&(byte ptr[esi+ecx]!='|')
					inc	ecx
				.endw
				xor	edx,edx
				.while (byte ptr[edi+edx]>32)
					inc	edx
				.endw
				mov	eax,ecx
				sub	eax,edx
				.if eax&80000000h
					neg	eax
				.endif
				.break .if eax>=_delta
				xor	ebx,ebx
				mov	letters,ebx
				.while ebx<edx
					mov	al,[edi+ebx]
					.if al!='@'
						or	al,20h
						mov	ah,[esi+ebx]
						or	ah,20h
						.if al==ah
							inc	letters
						.else
							mov	ah,[esi+ebx-1]
							or	ah,20h
							.if al==ah
								inc	letters
							.else
								mov	ah,[esi+ebx+1]
								or	ah,20h
								.if al==ah
									inc	letters
								.else
									mov	ah,[esi+ebx+2]
									or	ah,20h
									.if al==ah
										inc	letters
									.else
										mov	ah,[esi+ebx-2]
										or	ah,20h
										.if al==ah
											inc	letters
										.endif
									.endif
								.endif
							.endif
						.endif
					.else
						inc	letters
					.endif
					inc	ebx
				.endw
				xor	ebx,ebx
				xor	eax,eax
				.while ebx<edx
					.if byte ptr[edi+ebx]!=32 ;'@'
						inc	eax
					.endif
					inc	ebx
				.endw
				sub	eax,letters
				.if eax&80000000h
					neg	eax
				.endif
				.break .if eax>=(_delta*2)
				lea	esi,[esi+ecx]
				lea	edi,[edi+edx]
				.while (byte ptr[esi]==32)||(byte ptr[esi]==13)||(byte ptr[esi]==10)||(byte ptr[esi]==9)
					inc	esi
				.endw
				.while byte ptr[edi]==32
					inc	edi
				.endw
				.break .if byte ptr[edi]==0
				.break .if byte ptr[esi]==0
				.break .if byte ptr[esi]=='|'
			.endw
			.if ((byte ptr[esi]==0)||(byte ptr[esi]=='|'))&&(byte ptr[edi]==0)
				mov	esi,lpBuffer
				.while word ptr[esi]!=' >'
					inc	esi
				.endw
				inc	esi
				inc	esi
				lea	edi,answer
				mov	eax,hAlloc
				call	_trans_
				.while byte ptr[edi]
					.while (byte ptr[esi]==32)||(byte ptr[esi]==9)||(byte ptr[esi]==13)||(byte ptr[esi]==10)
						inc	esi
					.endw
					.while (byte ptr[edi]==32)||(byte ptr[edi]==9)||(byte ptr[edi]==13)||(byte ptr[edi]==10)
						inc	edi
					.endw
					.if byte ptr[edi]
						mov	al,[edi]
						or	al,20h
						mov	ah,[esi]
						or	ah,20h
						.break .if al!=ah
					.endif
					inc	esi
					inc	edi
				.endw
				.while (byte ptr[esi]==32)||(byte ptr[esi]==9)||(byte ptr[esi]==13)||(byte ptr[esi]==10)
					inc	esi
				.endw
				.if (byte ptr[edi]==0)&&((byte ptr[esi]==0)||(byte ptr[esi]=='|'))
					mov	answered,1
				.else
					mov	answered1,1
				.endif
				mov	eax,userId
				mov	lastpid,eax
				push	offset lastplayer
				push	eax
				call	NickFromId
				call	getscore
				mov	_locked,0

				mov	edi,hAlloc
				mov	esi,lpBuffer
				xor	ecx,ecx
				.while (byte ptr[esi]!='|')&&(byte ptr[esi]!=0)&&(ecx<1024)
					movsb
					inc	ecx
				.endw
				mov	ax,'|'
				stosw
				mov	eax,hAlloc
				lea	eax,[eax+4096]
				push	eax
				push	hAlloc
				push	offset mode0
				push	bothnd
				call	ModeTransform
				mov	edi,hAlloc
				mov	esi,edi
				lea	esi,[esi+4096]
				xor	ecx,ecx
				.while (byte ptr[esi]!='|')&&(byte ptr[esi]!=0)&&(ecx<1024)
					movsb
					inc	ecx
				.endw
				mov	eax,'H [ '
				stosd
				mov	eax,':tni'
				stosd
				mov	al,32
				stosb
				lea	edx,hint
				call	copyedx
				mov	ax,'] '
				stosw
				mov	al,'|'
				stosb
				mov	ecx,edi
				mov	edi,hAlloc
				sub	ecx,edi
				push	ecx
				push	edi
				call	SendToAll
				invoke	GlobalFree,hAlloc
				mov	noanswer,0
				xor	eax,eax
				ret
			.endif
			invoke	GlobalFree,hAlloc
		.endif
		mov	_locked,0
	.elseif (_started==1)&&(tflags&4)&&(byte ptr[eax]=='<')
		invoke	GetLocalTime,addr systime
		movzx	eax,systime.wHour
		mov	ecx,60
		xor	edx,edx
		mul	ecx
		movzx	edx,systime.wMinute
		add	eax,ecx
		sub	eax,chatqt
		.if eax&80000000h
			neg	eax
		.endif
		.if eax>qtimeout
			mov	chatq,0
		.endif
		mov	esi,lpBuffer
		xor	ecx,ecx
		.while (byte ptr[esi+ecx]!=0)&&(byte ptr[esi+ecx]!='|')&&(ecx<1022)
			.break .if byte ptr[esi+ecx]=='>'
			inc	ecx
		.endw
		.if byte ptr[esi+ecx]=='>'
			inc	ecx
		.endif
		.while (byte ptr[esi+ecx]<33)&&(byte ptr[esi+ecx]!=0)
			inc	ecx
		.endw
		.if ((byte ptr[esi+ecx]>='A')&&(byte ptr[esi+ecx]<='Z'))||(byte ptr[esi+ecx]>='a')||((byte ptr[esi+ecx]>='0')&&(byte ptr[esi+ecx]<='9'))
			.while (byte ptr[esi+ecx]!=0)&&(byte ptr[esi+ecx]!='|')&&(ecx<1022)
				.break .if byte ptr[esi+ecx]=='?'
				inc	ecx
			.endw
			.if byte ptr[esi+ecx]=='?'
				lea	edi,chatq
				.while byte ptr[esi]!='?'
					movsb
				.endw
				movsb
				mov	al,0
				stosb
				movzx	eax,systime.wHour
				mov	ecx,60
				xor	edx,edx
				mul	ecx
				movzx	edx,systime.wMinute
				add	eax,ecx
				mov	chatqt,eax
			.elseif chatq
				lea	edi,chatq
				xor	ecx,ecx
				.while byte ptr[esi+ecx]!='>'
					mov	al,[esi+ecx]
					.break .if al!=[edi+ecx]
					inc	ecx
				.endw
				mov	al,[esi+ecx]
				.if al!=[edi+ecx]
					.if questions==0
						mov	qsize,16384
						invoke	GlobalAlloc,GPTR,qsize
						mov	questions,eax
						mov	byte ptr[eax],0
					.endif
					mov	edi,questions
					xor	ecx,ecx
					.while byte ptr[edi+ecx]
						inc	ecx
					.endw
					sub	ecx,qsize
					neg	ecx
					.if ecx<4096
						add	qsize,16384
						invoke	GlobalAlloc,GPTR,qsize
						mov	edi,eax
						push	eax
						mov	esi,questions
						cld
						.while byte ptr[esi]
							movsb
						.endw
						movsb
						mov	eax,questions
						pop	questions
						invoke	GlobalFree,eax
					.endif
					mov	edi,questions
					.while byte ptr[edi]
						inc	edi
					.endw
					.if edi!=questions
						.if (byte ptr[edi-1]!=13)&&(byte ptr[edi-1]!=10)
							mov	ax,0a0dh
							stosw
						.endif
					.endif
					.if 0
						lea	edx,language
						mov	ecx,2
						.while (ecx!=0)&&(byte ptr[edx]!=0)
							mov	al,[edx]
							.if (al>='a')&&(al<='z')
								sub	al,32
							.endif
							stosb
							inc	edx
							dec	ecx
						.endw
					.endif
					mov	al,'|'
					stosb
					mov	eax,'tahC'
					stosd
					mov	al,'|'
					stosb
					lea	esi,chatq
					.if byte ptr[esi]=='<'
						inc	esi
					.endif
					.while (byte ptr[esi]!=0)&&(byte ptr[esi]!='>')
						movsb
					.endw
					mov	al,'|'
					stosb
					.if byte ptr[esi]=='>'
						inc	esi
					.endif
					.while (byte ptr[esi]<33)&&(byte ptr[esi]!=0)
						inc	esi
					.endw
					.while byte ptr[esi]
						movsb
					.endw
					mov	chatq,0
					mov	al,'|'
					stosb
					mov	esi,lpBuffer
					.while (byte ptr[esi]!=0)&&(byte ptr[esi]!='|')
						.break .if byte ptr[esi]=='>'
						inc	esi
					.endw
					.if byte ptr[esi]=='>'
						inc	esi
					.endif
					.while (byte ptr[esi]<33)&&(byte ptr[esi]!=0)
						inc	esi
					.endw
					xor	ecx,ecx
					mov	ah,32
					.while (byte ptr[esi]!=0)&&(byte ptr[esi]!='|')&&(ecx<200)
						lodsb
						.if (al<33)&&(ah!=32)
							mov	al,32
							stosb
							inc	ecx
							mov	ah,32
						.else
							mov	ah,0
							.if (al==':')||(al=='=')||(al==';')
								.if byte ptr[esi]=='-'
									inc	esi
								.endif
								.while 1
									.if (byte ptr[esi]=='(')||(byte ptr[esi]==')')||(byte ptr[esi]=='[')||(byte ptr[esi]==']')
										inc	esi
									.elseif (byte ptr[esi]=='{')||(byte ptr[esi]=='}')
										inc	esi
									.elseif (byte ptr[esi]=='p')||(byte ptr[esi]=='P')||(byte ptr[esi]=='s')||(byte ptr[esi]=='S')
										inc	esi
									.elseif (byte ptr[esi]=='d')||(byte ptr[esi]=='D')||(byte ptr[esi]=='x')||(byte ptr[esi]=='X')
										inc	esi
									.elseif (byte ptr[esi]=='<')||(byte ptr[esi]=='>')
										inc	esi
									.else
										.break
									.endif
								.endw
							.elseif (al=='!')||(al=='/')||(al=='+')||(al=='-')||(al=='(')||(al==')')||(al=='[')||(al==']')||(al=='{')||(al=='}')||(al=='<')||(al=='>')||(al=='@')
							.else
								stosb
								inc	ecx
							.endif
						.endif
					.endw
					.while byte ptr[edi-1]==32
						dec	edi
					.endw
					mov	al,'|'
					stosb
					mov	eax,defpoints
					call	itoa
					mov	eax,0a0dh
					stosd
				.endif
			.endif
		.endif
	.endif
	xor	eax,eax
	inc	eax
	ret
onChatMessage	ENDP

End DllEntry
